leetcode: 8. String to Integer (atoi)

6 篇文章 0 订阅
5 篇文章 0 订阅

一. 题目描述:

Implement atoi to convert a string to an integer.

Hint: Carefully consider all possible input cases. If you want a challenge, please do not see below and ask yourself what are the possible input cases.

Notes: It is intended for this problem to be specified vaguely (ie, no given input specs). You are responsible to gather all the input requirements up front.

Update (2015-02-10):
The signature of the C++ function had been updated. If you still see your function signature accepts a const char * argument, please click the reload button  to reset your code definition.

spoilers alert... click to show requirements for atoi.

二. 思路:

  • 字符串为空时返回0
  • 若字符串非空,使用trim方法去掉字符串的前后空格
  • 从字符串的第一个数字字符开始将去掉前后空格的字符串转化成数字,当字符串的第一个字符是正号或者负号的时候,开始转化的字符的索引值为1,否则,索引值为0
  • 转化的过程中检查转化结果(由于该结果可能溢出,所以使用long类型来存储)是不是超过了int最大能表示的范围,若超过则转化停止,否则继续将后续的字符转化成整数
  • 检查转化后的结果,若结果大于Integer.MAX_VALUE,返回Integer.MAX_VALUE;若结果小鱼Integer.MIN_VALUE,返回Integer.MIN_VALUE;其他的情况,直接将转化后的结果强转成int返回即可

三. 代码:

public class Solution {
    public int myAtoi(String str) {
        // trime leading and tailing spaces 
        str = str.trim();

        // if the lenght of stri is 0 or the first character of str is not reasonable, return 0 directly
        if (str.length() == 0){
            return 0;
        }

        int begin = 0;                                              // the index of first digit
        int sign = 1;                                               // the sign of the number. 1 represent the number is positive, or negative 
        if (str.charAt(0) == '-'){
            sign = -1;
            begin = 1;
        } else if (str.charAt(0) == '+'){
            begin = 1;
        }

        long sum = 0;                                               // handle integer overflow
        for (int i = begin; i < str.length(); i++){
            char ch = str.charAt(i);

            if (ch < '0' || ch > '9'){                                      // if the ch is not reasonable char, break the loop
                break;
            }

            sum = 10 * sum + (ch - '0');

            if (sum > Integer.MAX_VALUE){
                break;
            }

        }

        sum = sign == 1 ? sum : -sum;
        if (sum > Integer.MAX_VALUE){
            return Integer.MAX_VALUE;
        } else if (sum < Integer.MIN_VALUE){
            return Integer.MIN_VALUE;
        }

        return (int)sum;
    }

}
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值